#include <iostream>
#include <cassert>
using namespace std;

const int maxn = 200010;

int n,m,g[maxn],nxt[maxn],u[maxn],v[maxn];
int s[maxn],ans[maxn];

void Dfs(int x, int fr)
{
   int i = g[x];
   s[x] = 1; ans[x] = 0;
   while (i) {
      if (v[i] != fr) {
         Dfs(v[i],x); s[x] += s[v[i]];
         if (s[v[i]] > ans[x]) ans[x] = s[v[i]];
      }
      i = nxt[i];
   }
   if (n-s[x] > ans[x]) ans[x] = n - s[x];
}

void Add(int i)
{
   nxt[i] = g[u[i]]; g[u[i]] = i;
}

int main()
{
   int i;
   freopen("input.txt","rt",stdin); freopen("output.txt","wt",stdout);
   
   scanf("%d",&n); m = n-1;
   assert(1 <= n && n <= 100000);

   memset(g,0,sizeof(g)); memset(nxt,0,sizeof(nxt));
   for (i = 1; i <= m; i++) {
      scanf("%d%d",&u[i],&v[i]);
      assert(1 <= u[i] && u[i] <= n);
      assert(1 <= v[i] && v[i] <= n);
      u[m+i] = v[i]; v[m+i] = u[i];
      Add(i); Add(m+i);
   }   

   Dfs(1,0);
   for (i = 1; i <= n; i++) printf("%d ",ans[i]);

   fclose(stdout); fclose(stdout);
   return 0;
}
